---
# Documentation: https://sourcethemes.com/academic/docs/managing-content/

title: "Architectural Overview"
subtitle: "Overview of the architecture behind this website."
summary: "Overview of the architecture behind this website."
authors: ["admin"]
tags: []
categories: []
date: 2020-02-27T22:10:31+01:00
lastmod: 2020-02-27T22:10:31+01:00
featured: false
draft: false

# Featured image
# To use, add an image named `featured.jpg/png` to your page's folder.
# Focal points: Smart, Center, TopLeft, Top, TopRight, Left, Right, BottomLeft, Bottom, BottomRight.
image:
  caption: ""
  focal_point: ""
  preview_only: false

# Projects (optional).
#   Associate this post with one or more of your projects.
#   Simply enter your project's folder or file name without extension.
#   E.g. `projects = ["internal-project"]` references `content/project/deep-learning/index.md`.
#   Otherwise, set `projects = []`.
projects: []
---

## Introduction

I self host this site. I consider it a learning experience into hosting and managing a full linux server stack. The purpose of this post is to describe my current setup as notes to myself should I ever need to redo a similar setup. 

My setup attempts to achieve the following goals:

- Require no or little maintenance
  - I do not wish to daily check the status of the server
- High data integrity
  - Loosing data is not acceptable. Downtime while data is being recovered is however okay.
- Employ best practices
  - TLS, Git and containers are all considered best practices in modern software development.

Out of scope:

- Uptime and reliability
  - I self host and do not host any critical services.
- Performance and scaling
  - The server is purely for personal use and hardware is cheap.

## Hardware

The websever is hosted on an HP MicroServer Gen8. The OS runs off a 120GB SSD driver and 2x3TB HDD running RAID1 using the btrfs filesystem. This provides a suitable balance between storage capacity, and performance. Offsite back is done weekly through 

## Network

The server is connected via Gigabit Ethernet to an ASUS router. The router supports both IPv4 and IPv6 and does port forwarding for port 80 and port 443 to the statically configured IP address.

On the WAN side a 150/150Mb/sec fiber line from Altibox provides internet connection, while the IP address is not static it changes rarely enough for this not to be an issue.

The domain is registered via gandi.net providing both registration and name servers.

## Software

The software stack is built on containers. A reverse-proxy is employed to provide SSL certificates through LetsEncrypt. The webserver itself is Nginx running on an internal virtual network.

All containers are automatically updated as is the host system.

## Build

The site uses the hugo static site generator. The content of the site are maintained in a git repository. On each update to the repository a dedicated build server generates the HTML and pushes it to the webserver. This allows the site to be updated from any machine with access to git.
