---
# Documentation: https://sourcethemes.com/academic/docs/managing-content/

title: "Online Tools"
subtitle: "A range of high quality tools you can use from your browser on any system."
summary: "A range of high quality tools you can use from your browser on any system."
authors: []
tags: []
categories: []
date: 2020-04-08T22:09:37+02:00
lastmod: 2020-04-08T22:09:37+02:00
featured: false
draft: false

# Featured image
# To use, add an image named `featured.jpg/png` to your page's folder.
# Focal points: Smart, Center, TopLeft, Top, TopRight, Left, Right, BottomLeft, Bottom, BottomRight.
image:
  caption: ""
  focal_point: ""
  preview_only: false

# Projects (optional).
#   Associate this post with one or more of your projects.
#   Simply enter your project's folder or file name without extension.
#   E.g. `projects = ["internal-project"]` references `content/project/deep-learning/index.md`.
#   Otherwise, set `projects = []`.
projects: []
---
# Why

Sometimes you are simply stuck on a system where you can not install your own prefered tools. This is where online browser based tools comes to the assistance.

- [urlscan.io](https://urlscan.io/)
  - Scan a url and provide a detailed report. Great for checking suspicious links without opening them in your own browser.
  - {{< icon name="file-alt" pack="fas" >}} Report
- [CyberChef](https://gchq.github.io/CyberChef)
  - CyberChef is a highly flexible tool allowing you to combine small programmable blocks, that can process and convert data that you may stumble upon. Hexdumping, Base64, Hashing, Compression, EXIF and much much more.
  - {{< icon name="bug" pack="fas" >}} Debugging
- [Virus Total](https://www.virustotal.com/)
  - Provide a file or a URL and VirusTotal will scan the input using more than 70 different antivirus tools.
  - {{< icon name="file-alt" pack="fas" >}} Report
- [SSL Labs](https://www.ssllabs.com/ssltest/)
  - Perform a detailed analysis of your SSL/TLS server configuration. Includes feedback on which settings to optimize to improve the security.
- [Mozilla Observatory](https://observatory.mozilla.org/)
  - Similar to SSL Labs, Mozilla Observatory analyzes and provides feedback on how to improve the site.
  - {{< icon name="file-alt" pack="fas" >}} Report
- [Shodan](https://www.shodan.io/)
  - Shodan is for TCP/IP what Google is for the web. Shodan performs global ip and port scanning with the results easily accessible through a search engine.
  - {{< icon name="file-alt" pack="fas" >}} Search
- [Onlinedisassembler](https://onlinedisassembler.com/)
  - As the name suggest provides a purely online tool for analyzing binary executables.
  - {{< icon name="bug" pack="fas" >}} Debugging
- [Gitpod](https://gitpod.io/)
  - Online IDE built on Theia
  - {{< icon name="terminal" pack="fas" >}} Development
- [JSFiddle](https://jsfiddle.net/)
  - HTML/CSS/JavaScript sandbox
  - {{< icon name="terminal" pack="fas" >}} Development
- [repl.it](https://repl.it/)
  - Online IDE and runtime
  - {{< icon name="terminal" pack="fas" >}} Development
- [Puppeteer Sandbox](https://puppeteersandbox.com/)
  - Play with "Puppeteer" the headless interface for the Chrome browser. Automate scraping, screenshot, print-to-pdf, automatic testing etc.
  - {{< icon name="terminal" pack="fas" >}} Development
- [RESTNinja](https://restninja.io/)
  - Online REST client and HTTP requests playground. Make HTTP/AJAX requests.
  - {{< icon name="bug" pack="fas" >}} Debugging
- [HTTPbin](http://httpbin.org/)
  - REST endpoint for testing and development.
  - {{< icon name="bug" pack="fas" >}} Debugging